from api import *
from random import shuffle

# Fonction appelée au début de la partie.
liste_elements = [case_type.CUIVRE, case_type.FER, case_type.MERCURE, case_type.PLOMB, case_type.SOUFRE]
liste_transmutables_or = [case_type.CUIVRE, case_type.FER, case_type.PLOMB]
liste_transmutables_catalyseur = [case_type.MERCURE, case_type.SOUFRE]
qto = quantite_transmutation_or

me = moi()
him = adversaire()

COUT_OR = 1
COUT_CATALISEUR = 1
COUT_DANGER = 3

SEUIL_DANGER = 4
SEUIL_TAILLE = 7

regions = {me:[], him:[]}
region_point = {me : {(n%6,n//6):36 for n in range(36)}, him : {(n%6,n//6):36 for n in range(36)}}


def partie_init():
	pass

# Fonction appelée à chaque tour.
def jouer_tour():
	shuffle(liste_elements)
	me = moi()
	him = adversaire()
	tour = tour_actuel()
	maj_regions(me)
	
	aplacer = echantillon_tour()
	positions = placements_possible_echantillon(aplacer, me)
	
	while len(positions)==0:
		transmuter_une_fois()
		maj_regions(me)
		positions = placements_possible_echantillon(aplacer, me)
	
	if len(positions)==0:
		liste_tp=[]
		for l in range(6):
			for c in range(6):
				t = taille_region((c,l), me)
				liste_tp.append((t,(c,l)))
		liste_tp.sort()
		liste_tp.reverse()
		i=0
		while len(positions)==0:
			transmuter(liste_tp[i][1])
			i+=1
			positions = placements_possible_echantillon(aplacer, me)
	
	
	maj_regions(me)
	for i in range(6):
		for j in range(6):
			p='.'
			if region_point[me][(i,j)] != 36:
				p = str(gain_transmutation((i,j), me, regions[me][region_point[me][(i,j)]][0])[0])
			#print(p, end=' ')
		#print('')
	#print([e[0] for e in regions[me]])
	#print(evaluer())
	#print('')
	#print(perte_or_catalyse((2,2)))
	
	shuffle(positions)
	placer(positions)
	catalyse_moi(nombre_catalyseurs()//2)
	attaque(nombre_catalyseurs())
	transmuter_eventuellement()
	if tour_actuel() >= 149:
		transmuter_tout()
	donner()


def partie_fin(): # Fonction appelée à la fin de la partie.
    # Place ton code ici
    pass

def adjacents(pos, joueur): #débuggée
	x,y = pos
	adj = []
	for dx,dy in [(1,0),(-1,0),(0,1),(0,-1)]:
		case = type_case((x+dx,y+dy), joueur)
		if case != 0 and case != case_type.VIDE:
			adj.append((case, (x+dx,y+dy)))
	return adj

def gain_or_catalyse(pos): #renvoie (gain, element, nb de regions reliées)
	rep = (0, case_type.VIDE, 0)
	if nombre_catalyseurs()==0 or type_case(pos, me) == case_type.VIDE:
		return rep
	adj = adjacents(pos, me)
	if adj != []:
		cur_elem = type_case(pos, me)
		catalyser(pos, me, case_type.SOUFRE)
		regions = {elem : [] for elem in liste_transmutables_or}
		#dictionnaire de la forme {element : liste de (position, taille de la région)}
		for a in adj:
			elem, posi = a
			if elem in liste_transmutables_or:
				if regions[elem]==[]:
					regions[elem].append((posi, taille_region(posi, me)))
				else:
					b=True
					for p,t in regions[elem]:
						if posi in positions_region(p, me):
							b=False
							break
					if b:
						regions[elem].append((posi, taille_region(posi, me)))
		gain_max = 0
		print("regions =", regions)
		for elem in liste_transmutables_or:
			
			if elem != cur_elem:
				perte_cur_elem = (sum(t for p,t in regions[cur_elem])+1)**2//4 - sum(t*t//4-1 for p,t in regions[elem])
				gain = (sum(t for p,t in regions[elem])+1)**2//4-1 - sum(t*t//4-1 for p,t in regions[elem])-perte_cur_elem
				if gain > gain_max:
					gain_max = gain
					rep = (gain, elem, len(regions[elem]))
		annuler()
	return rep

def gain_or_catalyse2(pos): #renvoie (gain, element, nb de regions reliées)
	rep = (0, case_type.VIDE, 0)
	if nombre_catalyseurs()==0 or not(type_case(pos, me) in liste_transmutables_or):
		return rep
	adj = adjacents(pos, me)
	if adj != []:
		cur_elem = type_case(pos, me)
		catalyser(pos, me, case_type.SOUFRE)
		regs = {elem : [] for elem in liste_transmutables_or}
		#dictionnaire de la forme {element : liste de (position, taille de la région)}
		for a in adj:
			elem, posi = a
			if elem in liste_transmutables_or:
				if regs[elem]==[]:
					regs[elem].append((posi, taille_region(posi, me)))
				else:
					b=True
					for p,t in regs[elem]:
						if posi in positions_region(p, me):
							b=False
							break
					if b:
						regs[elem].append((posi, taille_region(posi, me)))
		gain_max = 0
		#print("regs =", regs)
		for elem in liste_transmutables_or:
			
			if elem != cur_elem:
				perte_cur_elem = qto((sum(t for p,t in regs[cur_elem])+1)) - sum(qto(t) for p,t in regs[elem])
				gain = qto((sum(t for p,t in regs[elem])+1)) - sum(qto(t) for p,t in regs[elem])-perte_cur_elem
				if gain > gain_max:
					gain_max = gain
					rep = (gain, elem, len(regs[elem]))
		annuler()
	return rep

def gain_transmutation(pos, joueur, t): #débuggée, revoie (gain en or, gain en catalyseurs)
	elem = type_case(pos, joueur)
	if propriete_case(pos, joueur) == element_propriete.TRANSMUTABLE_CATALYSEUR:
		return (quantite_transmutation_catalyseur_or(t), quantite_transmutation_catalyseur(t))
	elif propriete_case(pos, joueur) == element_propriete.TRANSMUTABLE_OR:
		return (quantite_transmutation_or(t), 0)
	else:
		return (0,0)

def est_lien(pos, joueur): #débuggée
	x,y = pos
	elem = type_case(pos, joueur)
	switch = 0
	b = (elem == type_case((x+1, y), joueur))
	for dx, dy in [(1,1),(0,1),(-1,1),(-1,0),(-1,-1),(0,-1),(1,-1),(1,0)]:
		b_tmp = (elem == type_case((x+dx, y+dy), joueur))
		if b != b_tmp and (b or dx*dy==0):
			switch += 1
			b = b_tmp
	return switch >= 4

def danger(liste_pos, joueur): #débuggée, renvoie le nombre de cases problématiques d'une liste de positions
	l = [p for p in liste_pos if est_lien(p, joueur)]
	return (len(l),l)

def maj_regions(joueur): #débuggée
	regions[me] = []
	dejavu = [[False]*6 for i in range(6)]
	for x in range(6):
		for y in range(6):
			if not(dejavu[x][y]):
				dejavu[x][y] = True
				elem = type_case((x,y), joueur)
				if elem != case_type.VIDE:
					region = positions_region((x,y), joueur)
					regions[me].append((len(region), elem, region))
					for i,j in region:
						dejavu[i][j] = True
						region_point[me][(i,j)]=len(regions[me])-1
				else :
					region_point[me][(x,y)] = 36
			
def evaluer(): #débuggée, renvoie un "score" de la grille
	or_tot, cat_tot, dang_tot= 0,0,0
	for region in regions[me]:
		dang = danger(region[2], me)
		gor, gcat = gain_transmutation(region[2][0], me, region[0])
		or_tot += gor
		cat_tot += gcat
		dang_tot += dang[0]
	return COUT_OR*or_tot + COUT_CATALISEUR*cat_tot - COUT_DANGER*dang_tot

def placer(liste_possibilites): #a priori débuggée, place un échantillon maximisant evaluer()
	pos1, pos2 = liste_possibilites[0]
	placer_echantillon(pos1, pos2)
	maj_regions(me)
	gain = evaluer()
	gain_max = gain
	position_max = (pos1, pos2)
	annuler()
	for pos1, pos2 in liste_possibilites:
		placer_echantillon(pos1, pos2)
		maj_regions(me)
		gain = evaluer()
		annuler()
		if gain > gain_max :
			gain_max = gain
			position_max = (pos1, pos2)
	pos1, pos2 = position_max
	placer_echantillon(pos1, pos2)
	return gain_max

def donner(): # ~débuggée
	elements_lui = [type_case((n%6,n//6), him) for n in range(36)]
	element_min = liste_elements[0]
	qmin = elements_lui.count(element_min)
	elem1, elem2 = echantillon_tour()
	for elem in liste_elements[1:]:
		q = elements_lui.count(elem)
		if q<qmin and not(elem in [elem1, elem2]): 
			qmin = q
			element_min = elem
	if elements_lui.count(elem1) < elements_lui.count(elem2):
		donner_echantillon((elem1, element_min))
	else:
		donner_echantillon((elem2, element_min))

def transmuter_une_fois(): # ~débuggée
	r_choisi = regions[me][0]
	taille_choisi = r_choisi[0]
	danger_choisi = danger(r_choisi[2], me)[0]
	for r in regions[me][1:]:
		dang = danger(r[2], me)[0]
		taille = r[0]
		if taille_choisi <= 1:
			r_choisi = r
			danger_choisi = dang
			taille_choisi = taille
		if danger_choisi <= 0:
			if dang > 1 and taille >= 2:
				r_choisi = r
				danger_choisi = dang
				taille_choisi = taille
			elif taille_choisi > taille and taille >= 2:
				r_choisi = r
				danger_choisi = dang
				taille_choisi = taille
		elif dang > 1 and taille_choisi < taille:
			r_choisi = r
			danger_choisi = dang
			taille_choisi = taille
		#print('dang          :', dang)
		#print('taille        :', taille)
		#print('danger_choisi :', danger_choisi)
		#print('taille_choisi :', taille_choisi)
		#print('')
	transmuter(r_choisi[2][0])

def catalyse_moi(n):
	liste_gain = []
	for x in range(6):
		for y in range(6):
			gain = gain_or_catalyse2((x,y))
			if gain[1] != case_type.VIDE:
				liste_gain.append((gain, (x,y)))
	liste_gain.sort()
	liste_gain.reverse()
	for gain, pos in liste_gain[:n]:
		catalyser(pos, me, gain[1])

def transmuter_eventuellement():
	for r in regions[me]:
		dang = danger(r[2], me)[0]
		taille = r[0]
		if dang >= SEUIL_DANGER and taille >= SEUIL_TAILLE:
			 transmuter(r[2][0])

def transmuter_tout():
	for r in regions[me]:
		taille = r[0]
		if taille >= 2:
			 transmuter(r[2][0])

def perte_or_catalyse(pos):
	rep = (0, case_type.VIDE, 0)
	if nombre_catalyseurs()==0 or not(type_case(pos, him) in liste_transmutables_or):
		return rep
	adj = adjacents(pos, him)
	if adj != []:
		cur_elem = type_case(pos, him)
		catalyser(pos, him, case_type.SOUFRE)
		regs = {elem : [] for elem in liste_transmutables_or}
		#dictionnaire de la forme {element : liste de (position, taille de la région)}
		for a in adj:
			elem, posi = a
			if elem in liste_transmutables_or:
				if regs[elem]==[]:
					regs[elem].append((posi, taille_region(posi, him)))
				else:
					b=True
					for p,t in regs[elem]:
						if posi in positions_region(p, him):
							b=False
							break
					if b:
						regs[elem].append((posi, taille_region(posi, him)))
		gain_min = 0
		#print("regs =", regs)
		for elem in liste_transmutables_or:
			
			if elem != cur_elem:
				perte_cur_elem = qto((sum(t for p,t in regs[cur_elem])+1)) - sum(qto(t) for p,t in regs[elem])
				gain = qto((sum(t for p,t in regs[elem])+1)) - sum(qto(t) for p,t in regs[elem])-perte_cur_elem
				print(gain)
				if gain < gain_min:
					gain_min = gain
					rep = (gain, elem, len(regs[elem]))
		annuler()
	return rep

def attaque(n):
	liste_perte = []
	for x in range(6):
		for y in range(6):
			perte = perte_or_catalyse((x,y))
			if perte[1] != case_type.VIDE:
				liste_perte.append((perte, (x,y)))
	liste_perte.sort()
	
	for perte, pos in liste_perte[:n]:
		catalyser(pos, him, perte[1])
